diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/syscomp/os_comms.p v15.6301-amd64/pop/src/syscomp/os_comms.p
--- pp0/v15.61-amd64/pop/src/syscomp/os_comms.p	2008-06-05 09:45:12.000000000 -0400
+++ v15.6301-amd64/pop/src/syscomp/os_comms.p	2009-12-24 15:48:52.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2008. All rights reserved. ----------
+/* --- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:			C.unix/src/syscomp/os_comms.p
  > Purpose:
  > Author:			John Gibson (see revisions)
@@ -120,23 +120,12 @@
 	if exlink then
 				out_obj_files(wobj_files)
 	else
-
-		;;; Altered by A.S. to produce a 'sh' file. 4 Jan 2005
-		;;; Altered by A.S. to produce a 'bash' file. 10 Sep 2007
-		;;; asmf_pr('#!/bin/csh -f\n');
-		;;; asmf_pr('#!/bin/sh\n');
-		asmf_pr('#!/bin/bash\n');
-
-		;;; asmf_printf(image_name, 'set IM=$1; if $IM == "" set IM=%p\n');
-		asmf_printf(image_name, 'IM=$1\n if [ ! ${IM} ]; then IM=%p ; fi\n');
+		asmf_pr('#!/bin/sh\n');
+		asmf_printf(image_name, 'IM=$1\nIM=${IM:-%p}\n');
 
 #_IF DEF cc_link_command_header
 		;;; Using C compiler to link (uses $POP__cc as command)
-		;;; asmf_pr('if ! $?POP__cc set POP__cc=cc\n');
-		asmf_pr('if [ ! ${POP__cc} ]; then POP__cc=cc; fi\n');
-
-		;;; shell-neutral bits follow.
-
+		asmf_pr('POP__cc=${POP__cc:-cc}\n');
 		asmf_pr(cc_link_command_header);
 		for f in link_flags do asmf_printf(f, '-Wl,%p \\\n') endfor;
 				out_obj_files(wobj_files);
@@ -190,13 +179,11 @@
 		endif);
 
 	unless exlink then
-		;;; asmf_pr('set ST = $status\n');
-		asmf_pr('ST=$status\n');
+		asmf_pr('ST=$?\n');
 
 		if cleanup_command then asmf_printf(cleanup_command, '%p\n') endif;
 		if makebase then
-			;;; asmf_pr('if ($ST == 0) rm -f $IM.stb\n')
-			asmf_pr('if [[ $ST == 0 ]]; then rm -f $IM.stb ; fi\n')
+			asmf_pr('if [ $ST == 0 ] ; then rm -f $IM.stb ; fi\n')
 		endif;
 		asmf_pr('exit $ST\n')
 	endunless;
@@ -322,113 +309,97 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, 5 Jun 2008
-		Altered to create a bash script header instead of sh for $popsys/poplink_cmnd
-		(Copied from 32 bit version)
---- Aaron Sloman and Waldek Hebisch 11 Mar 2005
-		Patched for AMD64
---- Aaron Sloman, Jan  4 2005
-        Changed gen_link_command to produce a version of $popsys/poplink_cmnd
-        that uses 'sh' syntax rather than 'csh', because not all linux systems
-        now come with csh or tcsh installed, which prevents re-linking.
---- Aaron Sloman, Dec 31 2004
-        Altered gen_link_command so that if motif is included it uses a link to
-        the appropriate file is made in
-            $popexternlib/libXm.so
-        e.g. in case there is not a libXm.so link in /usr/X11R6/lib
-        This requires the installation scripts to insert the link in
-        $popexternlib
 --- John Gibson, Apr  9 1999
-        Made out_obj_files convert -R<dirname> to appropriate -rpath args
-        for Linux
+		Made out_obj_files convert -R<dirname> to appropriate -rpath args
+		for Linux
 --- Julian Clinton, Aug  7 1998
-        Add '-lmw' for NCR.
+		Add '-lmw' for NCR.
 --- Robert Duncan, Jul  2 1998
-        Allowed for extra libraries in HP-UX link command
+		Allowed for extra libraries in HP-UX link command
 --- Robert Duncan, Jun 05 1998
-        Added libgen to link command for DG/UX (used at least by libXm)
+		Added libgen to link command for DG/UX (used at least by libXm)
 --- Robert Duncan, Aug 13 1996
-        Added libgen to link command for NCR (used at least by libXm)
+		Added libgen to link command for NCR (used at least by libXm)
 --- John Gibson, Dec  7 1995
-        Now allows env vars POP__as, POP__ar and POP__crt0 (if set) to
-        override AS_CMD, AR_CMD and unix_ld_crt_objects
+		Now allows env vars POP__as, POP__ar and POP__crt0 (if set) to
+		override AS_CMD, AR_CMD and unix_ld_crt_objects
 --- John Gibson, Mar 10 1995
-        OSF changes
+		OSF changes
 --- Poplog System, Jan 18 1995 (Julian Clinton)
-        Set options for Linux and SCO Open Desktop 3.0.
+		Set options for Linux and SCO Open Desktop 3.0.
 --- Robert John Duncan, Mar 21 1994
-        Changes for SG IRIX 5+
+		Changes for SG IRIX 5+
 --- John Gibson, Nov 19 1993
-        Changed gen_link_command to take ______exlink arg to say just produce
-        file containing object/library args
+		Changed gen_link_command to take ______exlink arg to say just produce
+		file containing object/library args
 --- John Gibson, Nov 13 1993
-        -lpop now the only pop library in link command
+		-lpop now the only pop library in link command
 --- John Gibson, Aug 30 1993
-        Replaced run*_poplink with run_comp_util
+		Replaced run*_poplink with run_comp_util
 --- John Gibson, Jul 10 1993
-        Added ________makebase argument to gen_link_command and assemble_and_link
+		Added ________makebase argument to gen_link_command and assemble_and_link
 --- Robert John Duncan, Jun 11 1993
-        Changed gen_link_command to write out explicit references to the pop
-        external libraries using the '-L' and '-l' options to ld and made it
-        take an additional argument -- _____________extern_libdir -- which is the
-        directory containing the libraries as determined by poplink. This is
-        necessary when the libraries are shared, because they may not be in
-        the same directory when the image is run.
-        Also tidied up references to the crt*.o files -- their location can
-        now be specified by defining unix_ld_crt_objects in "asmout.p".
+		Changed gen_link_command to write out explicit references to the pop
+		external libraries using the '-L' and '-l' options to ld and made it
+		take an additional argument -- _____________extern_libdir -- which is the
+		directory containing the libraries as determined by poplink. This is
+		necessary when the libraries are shared, because they may not be in
+		the same directory when the image is run.
+		Also tidied up references to the crt*.o files -- their location can
+		now be specified by defining unix_ld_crt_objects in "asmout.p".
 --- Simon Nichols, Jun  2 1993
-        Removed addition of -ldl/-ldld to link command -- now done with
-        a dummy exload in src/unixextern.p.
+		Removed addition of -ldl/-ldld to link command -- now done with
+		a dummy exload in src/unixextern.p.
 --- Robert John Duncan, Jun  2 1993
-        Changes for SVR4
+		Changes for SVR4
 --- John Gibson, May 23 1993
-        Removed addition of -lt*ermcap to link command -- now done with
-        a dummy exload in src/termcap.p.
+		Removed addition of -lt*ermcap to link command -- now done with
+		a dummy exload in src/termcap.p.
 --- John Gibson, May 14 1993
-        Added _______________cleanup_command arg to gen_link_command
+		Added _______________cleanup_command arg to gen_link_command
 --- John Gibson, May  6 1993
-        Removed addition of c_c*ore.obj from gen_link_command -- this is
-        now part of $popexternlib/libpop.olb.
+		Removed addition of c_c*ore.obj from gen_link_command -- this is
+		now part of $popexternlib/libpop.olb.
 --- Simon Nichols, Mar  2 1993
-        Changed location of crt?.o in Solaris 2.1
+		Changed location of crt?.o in Solaris 2.1
 --- Simon Nichols, Jan 29 1993
-        Changed name of conditional compilation flag SU*NOS_DYNAMIC to
-        SHARED_LIBRARIES, as it's more descriptive and not SunOS specific.
-        Added support for shared libraries on HP-UX.
+		Changed name of conditional compilation flag SU*NOS_DYNAMIC to
+		SHARED_LIBRARIES, as it's more descriptive and not SunOS specific.
+		Added support for shared libraries on HP-UX.
 --- John Gibson, Oct 20 1992
-        Changed os_library_command to hash-encode module names longer
-        than 14 chars
+		Changed os_library_command to hash-encode module names longer
+		than 14 chars
 --- Robert John Duncan, Jul 24 1992
-        Changed location of commands for SunOS 5.0 and the list of
-        libraries to be given to ld
+		Changed location of commands for SunOS 5.0 and the list of
+		libraries to be given to ld
 --- Robert John Duncan, Jul 21 1992
-        Added SYSTEM_V to list of systems which don't need ranlib
+		Added SYSTEM_V to list of systems which don't need ranlib
 --- Simon Nichols, Mar  3 1992
-        Changes to support SunOS dynamic linking (temporarily flagged by
-        SU*NOS_DYNAMIC).
+		Changes to support SunOS dynamic linking (temporarily flagged by
+		SU*NOS_DYNAMIC).
 --- Robert John Duncan, Jun 24 1991
-        Added code for SG IRIX
+		Added code for SG IRIX
 --- John Gibson, Jan 21 1991
-        Added -share- arg to -gen_link_command-
+		Added -share- arg to -gen_link_command-
 --- John Gibson, Nov 22 1990
-        Changed malloc.o to c_c*ore.obj
+		Changed malloc.o to c_c*ore.obj
 --- John Gibson, Nov 22 1990
 --- John Gibson, Sep 27 1990
-        Replaced calls of -interrupt- with mishaps
+		Replaced calls of -interrupt- with mishaps
 --- Rob Duncan, May 31 1990
-        Added non-standard run-time library for DECSTATION
+		Added non-standard run-time library for DECSTATION
 --- John Gibson, May 10 1990
-        Made $popsrc/malloc.o be systranslated (so it gets current
-        value of $popsrc).
+		Made $popsrc/malloc.o be systranslated (so it gets current
+		value of $popsrc).
 --- Rob Duncan, May  8 1990
-        Added patch for MIPS and funny runtime libraries for MIPS/RISCOS
+		Added patch for MIPS and funny runtime libraries for MIPS/RISCOS
 --- Rob Duncan, Nov  7 1989
-        Added t*ermcap library ('-lt*ermcap') to end of link command
+		Added t*ermcap library ('-lt*ermcap') to end of link command
 --- John Gibson, Aug  4 1989
-        Version 13.66+
+		Version 13.66+
 --- John Gibson, Jul 24 1989
-        -os_library_command- moved here from poplibr_main.p
+		-os_library_command- moved here from poplibr_main.p
 --- John Gibson, Jul 17 1989
-        Extracted from Unix versions of asmout.p
-        Added -run*_poplink-
+		Extracted from Unix versions of asmout.p
+		Added -run*_poplink-
  */
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/syscomp/symdefs.p v15.6301-amd64/pop/src/syscomp/symdefs.p
--- pp0/v15.61-amd64/pop/src/syscomp/symdefs.p	1997-03-05 10:35:08.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/symdefs.p	2009-12-24 15:32:15.000000000 -0500
@@ -131,6 +131,26 @@
 	word	K_END_V[0];			;;; dummy field to get word length of key
   };
 
+#_IF DEF FRAME_LEN_16BIT
+deftype
+  stk_off_t = short;
+constant macro PD_FRAME_SPARE = [ short PD_FRAME_SPARE_S ; ] ;
+#_ELSE
+#_IF DEF FRAME_LEN_32BIT
+deftype
+  stk_off_t = int;
+constant macro PD_FRAME_SPARE = [ 
+        short PD_FRAME_SPARE_S ;
+        int PD_FRAME_SPARE_I;
+] ;
+#_ELSE 
+deftype
+  stk_off_t = byte;
+constant macro PD_FRAME_SPARE = [] ;
+#_ENDIF
+#_ENDIF
+
+
 
 constant macro (
 	;;; start of all procedures
@@ -150,7 +170,8 @@
 		byte	PD_FLAGS2,			;;; second flags byte
 				PD_SPARE;			;;; currently unused
 		short	PD_REGMASK;			;;; mask for register locals
-		byte	PD_FRAME_LEN,		;;; total size of stack frame in words
+                PD_FRAME_SPARE
+		stk_off_t	PD_FRAME_LEN,		;;; total size of stack frame in words
 				PD_GC_OFFSET_LEN,	;;; word index from frame pointer to lowest addr lword for gc scan
 				PD_GC_SCAN_LEN,		;;; no of stack frame words for gc scan
 				PD_NUM_STK_VARS,	;;; no of stack allocated locals
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/syscomp/sysdefs.p v15.6301-amd64/pop/src/syscomp/sysdefs.p
--- pp0/v15.61-amd64/pop/src/syscomp/sysdefs.p	2005-03-13 04:58:29.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/sysdefs.p	2009-12-26 11:41:20.000000000 -0500
@@ -45,6 +45,8 @@
 	CODE_POINTER_TYPE = "byte",	;;; type of pointer to machine code
 	BIT_POINTER_TYPE = "byte",	;;; type of pointer for bitfield access
 
+        ;;; FRAME_LEN_32BIT = true,
+
 
 ;;; === OPERATING SYSTEM (UNIX BSD) ==================================
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/syscomp/w_util.p v15.6301-amd64/pop/src/syscomp/w_util.p
--- pp0/v15.61-amd64/pop/src/syscomp/w_util.p	1995-11-10 09:15:14.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/w_util.p	2009-12-30 14:27:21.000000000 -0500
@@ -179,7 +179,7 @@
 	*/
 define word_dict_cell(word);
 	lvars string = fast_word_string(word), len = datalength(string), word;
-
+#_IF false
 	if len fi_> 2 then
 		;;; use first, middle and last chars and length
 		f_subs(1,string) fi_+ len
@@ -195,7 +195,29 @@
 	else
 		0
 	endif -> len;
-	(len fi_&& 16:3FF) fi_+ 1
+#_ELSE
+    lvars res = len, i = 1;
+    while len fi_> 3 do
+        (f_subs(i, string) fi_+ (f_subs(i fi_+ 1, string) fi_<< 8) 
+           fi_+ (f_subs(i fi_+ 2, string) fi_<< 16))
+           + (f_subs(i fi_+ 3, string) << 24) + res -> res;
+        len fi_- 4 -> len;
+        i fi_+ 4 -> i;
+    endwhile;
+    if len == 3 then
+        (f_subs(i, string) fi_+ (f_subs(i fi_+ 1, string) fi_<< 8) 
+           fi_+ (f_subs(i fi_+ 2, string) fi_<< 16))
+             + res -> res;
+    elseif len == 2 then
+        (f_subs(i, string) fi_+ (f_subs(i fi_+ 1, string) fi_<< 8))
+             +  res -> res;
+    elseif len == 1 then
+        f_subs(i, string) + res -> res;
+    endif;
+    ;;; Mix bits
+    ((res && 16:FFFE0000) >> 17) ||/& res -> res;
+#_ENDIF
+    (res && 16:3FF) fi_+ 1
 enddefine;
 
 define path_index_cell(pathstr, word);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/termcap.p v15.6301-amd64/pop/src/termcap.p
--- pp0/v15.61-amd64/pop/src/termcap.p	2005-03-13 18:49:05.000000000 -0500
+++ v15.6301-amd64/pop/src/termcap.p	2009-12-24 15:31:23.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 1998. All rights reserved. ----------
  > File:            C.unix/src/termcap.p
  > Purpose:         Simple interface to C termcap library
  > Author:          Rob Duncan, Apr 11 1989 (see revisions)
@@ -11,8 +11,6 @@
 	*/
 #_TERMIN_IF DEF NCR
 
-/* Too many problems with termcap on linux systems. */
-/* But include the rest of this for now, for ncurses */
 #_TERMIN_IF false
 
 #_INCLUDE 'declare.ph'
@@ -600,14 +598,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Mar 13 2005
-		Reinstated
-			 #_TERMIN_IF false
-		to enable Waldek's changes to operate
-		(for ncurses)
---- Aaron Sloman, Mar 13 2005
-		Reinstated this for AMD64 poplog
-			 #_TERMIN_IF DEF LINUX
 --- John Gibson, Mar 26 1998
 		Set -lcurses for AIX
 --- Robert Duncan, Aug 14 1997
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/unixdefs.ph v15.6301-amd64/pop/src/unixdefs.ph
--- pp0/v15.61-amd64/pop/src/unixdefs.ph	2005-03-11 13:59:38.000000000 -0500
+++ v15.6301-amd64/pop/src/unixdefs.ph	2009-12-24 15:31:05.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:			C.unix/src/unixdefs.ph
  > Purpose:
  > Author:			John Gibson (see revisions)
@@ -52,7 +52,6 @@
 	dev_t	= double,
 	ino_t	= long,
 	mode_t	= int,
-;;;	nlink_t	= int,
 	nlink_t	= long,
 	time_t	= -long,
 	uid_t	= int,
@@ -640,8 +639,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Mar 11 2005
-		Changed for AMD64
 --- John Gibson, Apr  9 1999
 		Replaced test ALPHA_LINUX or (X86_LINUX and LIN*UX_GLI*BC) with
 		DEFV LINUX >= 2.0
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/vec_generic.p v15.6301-amd64/pop/src/vec_generic.p
--- pp0/v15.61-amd64/pop/src/vec_generic.p	1997-02-12 12:29:00.000000000 -0500
+++ v15.6301-amd64/pop/src/vec_generic.p	2009-12-30 14:59:15.000000000 -0500
@@ -44,8 +44,26 @@
 enddefine;
 
 define Byte_hash(_cptr, _len);
+#_IF false
 	lvars _len, _cptr;
 	CHAR_HASH(b)
+#_ELSE
+    lvars _res = _len;
+    while _len _sgr _3 do
+        _cptr!(i) _add _res -> _res;
+        _len _add _-4 -> _len;
+        _cptr _add _4 -> _cptr;
+    endwhile;
+    if _len == _3 then
+        (_cptr!(i) _bimask _16:FFFFFF) _add _res -> _res;
+    elseif _len == _2 then
+        _cptr!(s) _add _res -> _res;
+    elseif _len == _1 then
+        _cptr!(b)[_0] _add _res -> _res;
+    endif;
+   ;;; Mix bits
+   _shift(_res _bimask _16:FFFE0000, _-17) _bixor _res
+#_ENDIF
 enddefine;
 
 define Short_hash(_cptr, _len);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/vm_conspdr.p v15.6301-amd64/pop/src/vm_conspdr.p
--- pp0/v15.61-amd64/pop/src/vm_conspdr.p	2005-02-12 15:05:49.000000000 -0500
+++ v15.6301-amd64/pop/src/vm_conspdr.p	2009-12-27 00:36:41.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 2003. All rights reserved. ----------
  > File:            C.all/src/vm_conspdr.p
  > Purpose:
  > Author:          John Gibson, Mar 11 1988 (see revisions)
@@ -387,6 +387,9 @@
 	enduntil;
 	instr!INST_OP -> _op;
 	if _op == I_NOT then
+                ;;; Check for double negation, we could do better but
+                ;;; this is very rare.
+                returnif(is_not)(false);
 		Optimise_clist_tl(next_clist, true)
 	else
 		if IS_UNOPT_JUMP(_op) ->> _op then
@@ -1176,11 +1179,10 @@
 	endif;
 
 	Incr_lab_refcount(asm_exit_lab);
-	;;; check proposed by Waldek Hebisch
-	if _Nframewords _gr _16:FF then
-		mishap(0, 'PROCEDURE STACK FRAME TOO LARGE (too many lvars?)');
-	endif;
 
+        if _Nframewords _gr _:MAX_STACK_FRAME_SIZE then
+          mishap(0, 'PROCEDURE STACK FRAME TOO LARGE (too many lvars?)');
+        endif;
 	;;; first instruction creates stack frame on entry
 	Cons_inst(I_CREATE_SF, 1) :: codelist -> codelist;
 
@@ -1235,8 +1237,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Feb 12 2005
-		Check for stack frame limit exceeded suggested by Waldek Hebisch
 --- David Young, Oct  8 2003
         Fixed bug in Optimise_conditions which caused a sequence of I_NOTs
         followed by an I_GOTO to be incorrectly ignored. This was
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/ved/src/vdfiles.p v15.6301-amd64/pop/ved/src/vdfiles.p
--- pp0/v15.61-amd64/pop/ved/src/vdfiles.p	2008-06-05 09:55:33.000000000 -0400
+++ v15.6301-amd64/pop/ved/src/vdfiles.p	2008-02-06 18:06:20.000000000 -0500
@@ -710,7 +710,6 @@
 #_ELSE
 				sysfileok(file) -> file;
 				current_directory -> dir;
-				;;; datalength(dir) fi_+ datalength(file) -> totlen;
 				datalength(dir) fi_+ 1 fi_+ datalength(file) -> totlen;
 				fast_for tempfile in vedbufferlist do
 					fast_subscrv(VF_PATHNAME,tempfile) -> vfname;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/ved/src/vdwindows.p v15.6301-amd64/pop/ved/src/vdwindows.p
--- pp0/v15.61-amd64/pop/ved/src/vdwindows.p	2005-03-11 21:06:41.000000000 -0500
+++ v15.6301-amd64/pop/ved/src/vdwindows.p	1999-07-12 14:08:41.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005.  All rights reserved. ---------
+/* --- Copyright University of Sussex 1997.  All rights reserved. ---------
  > File:        C.all/ved/src/vdwindows.p
  > Purpose:     Manipulating windows on screen
  > Author:      Aaron Sloman & John Gibson (see revisions)
@@ -94,8 +94,8 @@
 ;;;     of ratios.
 
 lvars
-	startwindow_size    = 18,
-	startwindow_base    = 36,
+	startwindow_size    = 12,
+	startwindow_base    = 24,
 ;
 
 /*
@@ -758,7 +758,7 @@
 		vederror('\{b}only editing one file');
 	endif;
 
-	syssleep(40);
+	syssleep(40);	;;; Added by A.Sloman 12 Jul 1999
 
 	if vedinputwaiting() then
 		;;; don't display message if char is waiting
@@ -897,13 +897,9 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Mar 12 2005
-		Changed these two
-			startwindow_size    = 18,
-			startwindow_base    = 36,
 --- Aaron Sloman, 12 Jul 1999
-		Removed spurious "true" in call of vedputmessage in vedfileselect
-		added syssleep
+		Removed spurious true in call to vedputmessage, and added
+		syssleep in vedfileselect.
 --- John Gibson, Aug 15 1997
 		Changes for XVed variable-width mode
 --- John Gibson, May  2 1997
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/x/pop/lib/Xm/xmTextFieldWidget.p v15.6301-amd64/pop/x/pop/lib/Xm/xmTextFieldWidget.p
--- pp0/v15.61-amd64/pop/x/pop/lib/Xm/xmTextFieldWidget.p	2005-02-23 16:01:51.000000000 -0500
+++ v15.6301-amd64/pop/x/pop/lib/Xm/xmTextFieldWidget.p	2009-12-24 16:14:31.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:			C.x/x/pop/lib/Xm/xmTextFieldWidget.p
  > Purpose:			Motif widgetclass
  > Author:			John Gibson, Apr 14 1993 (see revisions)
@@ -55,8 +55,10 @@
 	XmTextFieldClearSelection(widget,time) :void,
 	XmTextFieldCopy(widget,time) :XptBoolean,
 	XmTextFieldCut(widget,time) :XptBoolean,
-;;; No longer causes problem with lesstif
+;;; Now one that doesn't work with lesstif
+#_IF not(DEF LINUX)
 	XmTextFieldGetAddMode(widget) :XptBoolean,
+#_ENDIF
 	XmTextFieldGetBaseLine(widget) :int,
 	XmTextFieldGetBaseline(widget) :int,
 	XmTextFieldGetCursorPosition(widget) :XmTextPosition,
@@ -111,8 +113,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Feb 23 2005
-		Undid last change, since it now works with Lesstif
 --- Aaron Sloman, Nov  6 1999
 	On Julian Clinton's advice, prevented compilation of this line
 		XmTextFieldGet*AddMode(widget) :XptBoolean,
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/x/pop/lib/Xm/xmTextWidget.p v15.6301-amd64/pop/x/pop/lib/Xm/xmTextWidget.p
--- pp0/v15.61-amd64/pop/x/pop/lib/Xm/xmTextWidget.p	2005-02-23 15:59:18.000000000 -0500
+++ v15.6301-amd64/pop/x/pop/lib/Xm/xmTextWidget.p	2010-01-03 06:49:16.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2005. All rights reserved. ----------
+/* --- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:			C.x/x/pop/lib/Xm/xmTextWidget.p
  > Purpose:			Motif widgetclass
  > Author:			John Gibson, Apr 14 1993 (see revisions)
@@ -58,8 +58,10 @@
 	XmTextClearSelection(widget,time) :void,
 	XmTextCopy(widget,time) :XptBoolean,
 	XmTextCut(widget,time) :XptBoolean,
-;;; No longer causes problem with lesstif
+;;; Now one that doesn't work with lesstif
+#_IF not( DEF LINUX )
 	XmTextGetAddMode(widget) :XptBoolean,
+#_ENDIF
 	XmTextGetBaseLine(widget) :int,
 	XmTextGetBaseline(widget) :int,
 	XmTextGetCursorPosition(widget) :XmTextPosition,
@@ -128,8 +130,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Feb 23 2005
-		Undid last change, since it now works with Lesstif
 --- Aaron Sloman, Nov  6 1999
 	On Julian Clinton's advice, prevented compilation of this line
 		XmTextGet*AddMode(widget) :XptBoolean,
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/x/ui/lib/pop_ui_logo.p v15.6301-amd64/pop/x/ui/lib/pop_ui_logo.p
--- pp0/v15.61-amd64/pop/x/ui/lib/pop_ui_logo.p	1996-07-18 04:36:09.000000000 -0400
+++ v15.6301-amd64/pop/x/ui/lib/pop_ui_logo.p	2009-12-24 15:29:59.000000000 -0500
@@ -58,7 +58,7 @@
 	POPUIBITMAPS  dir_>< 'poplog_64.xbm', ;;; filename of xbm
 
 	sprintf(pop_internal_version / 10000.0, 'Sussex Poplog Version %p'),
-	'   Copyright \(169) 1982-1996, The University of Sussex   ',
+	'   Copyright \(169) 1982-2005, The University of Sussex   ',
 	'All Rights Reserved.',
 	'',
 	popmemused div 256 sys_>< ' Kilobytes used, ' sys_><
@@ -66,7 +66,12 @@
 	'    (editing ' sys_>< len sys_>< ' file',
 	if len ==  1 then sys_>< ')    ' else sys_>< 's)    ' endif,
 	'',
-	'Marketed under licence by:', 'Integral Solutions Ltd.',
+	'Poplog is free sftware, see:',
+        'http://www.cs.bham.ac.uk/research/poplog/freepoplog.html',
+        'and ftp://ftp.cs.bham.ac.uk/pub/dist/poplog/',
+        '',
+        'Previously marketed by:',
+        'Integral Solutions Ltd.',
 	'Berk House, Basing View',
 	'Basingstoke, Hants.',
 	'RG21 4RG, UK',
@@ -74,8 +79,6 @@
 	'Tel: +44 (0)1256 55899',
 	'Fax: +44 (0)1256 63467',
 	'',
-	'Email: isl@isl.co.uk',
-	'URL: http://www.isl.co.uk',
 	''
 	%]
 enddefine;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/x/ved/src/xvedinput.p v15.6301-amd64/pop/x/ved/src/xvedinput.p
--- pp0/v15.61-amd64/pop/x/ved/src/xvedinput.p	2005-03-11 05:30:40.000000000 -0500
+++ v15.6301-amd64/pop/x/ved/src/xvedinput.p	2010-01-03 03:47:30.000000000 -0500
@@ -55,7 +55,7 @@
 
 define xved_raise_event(window, name, data);
 	lvars next_pos;
-;;; printf('xved_raise_event0\n');
+
 	if name == "userInterrupt" and vedinvedprocess then
 		;;; user interrupt bypass the event dispatching process
 #_IF DEF sys_send_signal
@@ -79,7 +79,6 @@
 		next_pos -> write_pos
 	endif;
 
-
 	returnif((ADVANCE_POS(write_pos) ->> next_pos) == read_pos);
 	;;; set input at write position
 	conspair(name, data) -> BUF_ENTRY(write_pos);
@@ -106,7 +105,7 @@
 
 define xved_raise_ascii(window, string);
 	lvars window, string, n, m, c1, next_pos;
-;;; printf('xved_raise_ascii\n');
+
 	unless window.wved_is_live_window then
 		vederror('xved_raise_ascii: not a valid window');
 	endunless;
